<?php

class restapi_Classofservice {
	private $api;
    	
	function __construct($api) {
		$this->api = & $api;
	}	
	
	function index() {
		return $this->get();
        }

       /**
	* @verb GET
	* @returns 
	* @uri /cos
	*/
        function get($params) {
        
	}

	/**
         * @verb GET
         * @returns - true if cos module is licensed, false otherwise
         * @uri /cos
         */
         function get_cos($params) {
		$cos = $this->cos_module();
		if ($cos) {
	                return true;
		}

		return false;
         }

	/**
	 * @verb GET
	 * @returns - cos allowed category
	 * @uri /cos/users/:id/:category
	 */
	function get_cos_users_id_category($params) {

		/* 'features' used to be hardcoded in the API, before arbitrary categories were allowed.  Use 'fc' instead. */
		if ($params['category'] == 'features') {
			$params['category'] = 'fc';
		}

		$cos = $this->cos_module();
		if ($cos) {
			$uCos = $cos->getCoSforUser($params['id']);
			if ($uCos) {
				$allowed = array();

				foreach ($uCos as $c) {
					$conf = $cos->getConfig($params['category'] . 'allow', $c);
					foreach ($conf as $key => $val) {
						$allowed[$key] = $val;
					}
				}

				return $allowed;
			}
		}

		return false;
	}

	function cos_module() {
		global $bmo;

		if ($bmo && $bmo->Cos && $bmo->Cos->isLicensed()) {
			$cos = $bmo->Cos;
		} else if (function_exists('cos_islicenced') && cos_islicenced()) {
			$cos = Cos::create();
		}

		return $cos;
	}
}
