<?php
namespace FreePBX\modules\Sms\Adaptor;
class Sipstation extends \FreePBX\modules\Sms\AdaptorBase {
	//	License for all code of this FreePBX module can be found in the license file inside the module directory
	//	Copyright 2013 Schmooze Com Inc.
	//

	protected $sms_server = 'trunk1.freepbx.com';
	public function __construct($ss=null) {
		parent::__construct();
		if (!empty($ss)) {
			$key = $ss->get_key();
			if(!empty($key)) {
				$c = $ss->get_settings($key, false);
				if(!empty($c['gateways'][1])) {
					$this->sms_server = $c['gateways'][1];
				}
			}
		}
	}

	/**
	* Create the Notification Class statically while checking to make sure the class hasn't already been loaded
	*
	* @param object Database Object
	* @return object Notification object
	*/
	static function &create($ss=null) {
		static $obj;
		if (!isset($obj)) {
			$obj = new Sipstation($ss);
		}
		return $obj;
	}

	public function showDID($id, $did) {
		return \FreePBX::Ucp()->getCombinedSettingByID($id,'Sipstation','sms_enable');
	}

	public function sendMessage($to,$from,$cnam,$message) {
		$id = parent::sendMessage($to,$from,$cnam,$message);
		$astman = \FreePBX::create()->astman;
		$cnam = !empty($cnam) ? '"'.utf8_decode($cnam).'"' : '';
		if(class_exists("Emojione")) {
			$message = \Emojione::shortnameToAscii($message);
		}
		$res = $astman->MessageSend('sip:'.$to.'@'.$this->sms_server, $cnam.' <sip:+'.$from.'@'.$this->sms_server.'>', $message);
		$final = array();
		if(!empty($res['Response']) && ($res['Response'] == 'Success')) {
			return $final = array("status" => true, "id" => $id);
		} else {
			return $final['status'] = false;
		}
	}

	public function getMessage($to,$from,$cnam,$message) {
		parent::getMessage($to,$from,$cnam,$message);
	}

	public function dialPlanHooks(&$ext, $engine, $priority) {
		global $core_conf;

		//need to get the list of trunks we control.
		//\FreePBX::PJSip()->addEndpoint('test','message_context','sms-incoming');

		$c = 'sms-incoming';
		$ext->add($c, '_.', '', new \ext_noop('SMS came in with DID: ${EXTEN}'));
		$ext->add($c, '_.', '', new \ext_goto('1', 's'));
		$ext->add($c, 's', '', new \ext_agi('sipstation_sms.php, RECEIVE'));
		$ext->add($c, 's', '', new \ext_hangup());

		$core_conf->addSipGeneral('accept_outofcall_message','yes');
	}
}
