Sysadmin_SSL = new function() {
	// If ajaxurl isn't already defined...
	if (typeof(window.ajaxurl) =='undefined') {
		var path = window.location.pathname.toString().split('/');
		path[path.length - 1] = 'ajax.php';
		// Oh look, IE. Hur Dur, I'm a bwowsah.
		if (typeof(window.location.origin) == 'undefined') {
			window.location.origin = window.location.protocol+'//'+window.location.host;
		}
		window.ajaxurl = window.location.origin + path.join('/');
	};

	// If modulename isn't already defined...
	if (typeof(window.modulename) == 'undefined') {
		// This assumes the module name is the first param.
		window.modulename = window.location.search.split(/\?|&/)[1].split('=')[1];
	};

	this.generateSSC = function() {
		$("#resultmsg").html("Generating, please wait... (This may take up to 30 seconds)");
		$.ajax({
			url: window.ajaxurl,
			data: { command: 'genselfsigned', module: window.modulename, cn: $("#autocn").val() },
			success: function(data) { Sysadmin_SSL.sscGenerated(data); },
			error: function(data) { console.log("Shits all fucked up man"); },
		});
	};

	this.sscGenerated = function(d) {
		$("#resultmsg").html(d.message);
		$("#autogen").removeAttr("disabled").html("Generate");
	};

	this.refreshSettings = function() {
		$.ajax({
			url: window.ajaxurl,
			data: { command: 'getsslsettings', module: window.modulename, },
			success: function(data) { Sysadmin_SSL.updateSettings(data); },
		});
	};

	this.updateSettings = function (d) {
		window.supresserrors = false;

		$("#localcert").html(d.localcert);

		if (typeof(d.issuer) == "undefined") {
			$(".certdetails").hide();
		} else {
			$(".certdetails").show();
			$("#certcn").html(d.subject.CN);
			$("#certissuer").html(d.issuer.CN);
		}
		if (d.caninstall) {
			$("#caninstallcert").show();
		} else {
			$("#caninstallcert").hide();
		}

		$("#apachestatus").html(d.apache.status);
		if (typeof(d.apache.cert) == "undefined") {
			$(".apachedetails,#sslintegration").hide();
		} else {
			$(".apachedetails,#sslintegration").show();
			$("#apachecn").html(d.apache.cert.subject.CN);
			$("#apacheissuer").html(d.apache.cert.issuer.CN);
			if (typeof(d.sslintegrated) == "undefined") {
				$("#dointegratessl").show();
				$("#removeintegratessl").hide();
			} else {
				$("#dointegratessl").hide();
				$("#removeintegratessl").show();
			}
		}
	};

	this.installPendingCerts = function() {
		window.supresserrors = true;
		$("#localcert").html("<i>Installing...</i>");
		$("#apachestatus").html("");
		$("#caninstallcert").hide();
		$(".apachedetails").hide();
		$(".certdetails").hide();
		$.ajax({
			url: window.ajaxurl,
			data: { command: 'installpendingcerts', module: window.modulename, },
			// This means something broke.
			success: function(data) { Sysadmin_SSL.updateSettings(data); },
			// Normally, it'll crash as apache restarts
			error: function(data) { Sysadmin_SSL.waitForRestart(data); },
		});
	};

	this.waitForRestart = function(d) {
		console.log(d);
		if (d.status == 0) {
			// Well, apache is down. Let's have a snooze for a bit and then try again.
			window.setTimeout(function() {
				$.ajax({
					url: window.ajaxurl,
					data: { command: 'getsslsettings', module: window.modulename, },
					success: function(data) { Sysadmin_SSL.updateSettings(data); },
					error: function(data) { Sysadmin_SSL.waitForRestart(data); },
				});
			}, 1000);
		}
	};

	this.checkCSR = function(e) {
		if ($("#csrcn").val().length == 0) {
			e.preventDefault();
			$("#csrcn").addClass("pulsebg");
			window.setTimeout(function() { $("#csrcn").removeClass("pulsebg"); }, 2000);
		}
		if ($("#csro").val().length == 0) {
			e.preventDefault();
			$("#csro").addClass("pulsebg");
			window.setTimeout(function() { $("#csro").removeClass("pulsebg"); }, 2000);
		}
	};

	this.doIntegrateSSL = function() {
		$("#dointegratessl").prop("disabled", true);
		$.ajax({
			url: window.ajaxurl,
			data: { command: 'dointegratessl', module: window.modulename, },
			complete: function(data) { 
				$("#dointegratessl").prop("disabled", false).hide();
				Sysadmin_SSL.refreshSettings();
			},
		});
	};

	this.removeIntegrateSSL = function() {
		$("#removeintegratessl").prop("disabled", true);
		$.ajax({
			url: window.ajaxurl,
			data: { command: 'removeintegratessl', module: window.modulename, },
			complete: function(data) {
				$("#removeintegratessl").prop("disabled", false).hide();
			       	Sysadmin_SSL.refreshSettings();
			},
		});
	};
}
